- Eine Platine pro Heizung.
  - Aber einen zweiten Kanal vorsehen, damit man zwei Heizungen hängen kann.
- RS485 Bus.
  - Bus ist ernstgemeint, d.h. eine lange Kette, keine Stichleitungen und Abschlusswiderstände am Ende.
  - Entweder an einer Stelle auf LAN brücken, z.B. mit https://www.waveshare.com/wiki/RS485_TO_POE_ETH_(B)
  - Oder per Netzwerkkabel plus USB zu vogon. Das Netzwerkkabel natürlich so, dass es nicht einfach auf Netzwerk zurücksteckbar ist.
  - Protokoll z.B. Modbus RTU oder was eigenes in Anlehnung daran.
- Abzweigdose als Gehäuse
  - 10pcs, 0.82€ pro Stück, https://www.hornbach.de/p/spelsberg-abzweigkasten-ip55-i12-85x85-mm-33291201-ohne-klemmen-12-einfuehrungen-10-stueck/6060830/
  - https://www.spelsberg.de/verbindungsdosen/innenbereich-bis-252/33291201/
  - Ich würde außen schrauben vorschlagen (oder Gecko-Tape), aber würde die Schraublöcher in den Ecken aussparen - nur so für den Fall.
  - Auch die beiden "Pins" in der Mitte aussparen (sind die zum Befestigen von Wago-Klemmen..?).
  - Platine auch per Gecko festkleben? Ich denke ja.
- MCU
  - Warum RP2040?
    - Klassische Wahl wäre ein ATmega328.
    - Aber RP2040 hat eigentlich keine Nachteile und der USB Bootloader klärt die Frage, wie man es schafft, dass bei Problemen jeder
      die Firmware ohne RS485 Bootloader programmieren kann.
    - Den Flash können wir groß genug machen, dass man eine Art A/B Partition vorsehen kann.
      - Direkt A/B geht nicht, weil dem XIP kann man anscheinend keinen Offset vorgeben und dann müsste alles ohne XIP oder mit `-fPIC` sein.
      - Aber Leute haben sich was überlegt: https://github.com/rhulme/pico-flashloader
      - Dem könnte man noch ein "boote in die alte Version" geben, wenn man immer zwei Images da liegen hat und noch einen Button spendiert.
    - Weiterer Vorteil wäre, dass es ein richtiger ARM ist, d.h. LLVM und Rust sind kein Problem. Genug RAM für sinnvoll MicroPython, falls
      man das mal will. Und es ist ein Dual-Core. Wobei wir darauf hier ehrlich gesagt verzichten könnten, weil C und Mini-Programm reicht.
    - Ah, und JLC bestückt uns zwar auch den ATmega328P - aber für 3€ statt 1€!
    - Nachteil: Nur 4 ADC Pins.
    - Nachteil: Hardware-Design ist (abgesehen vom Programmer) etwas aufwändiger als beim ATmega. Aber ich würde einfach den Raspi Pico kopieren.
  - ...
- Kabel
  - fxk8y hat 7-fach Steuerleitung vorgeschlagen, bei Alpha verfügbar. Konkret: Tronic LIYY 7x0.5
  - 2x 24V, 2x GND, 2x RS485 A/B, 1x WS2811
  - Die siebte Leitung ist frei und da noch mal GND zu machen oder so klingt nicht sinnvoll. Stattdessen einen WS2811 auf die Platine zum Signal
    verstärken und dann kann man quasi an beliebigen Stellen LED-Streifen verteilen.
  - Auch noch eine WS2812-4020 mit aufs PCB zum Debuggen.
  - Der WS2811 hängt am MCU. Das könnte praktisch sein für Auto-Discovery Dinge.
  - RS485 ist nicht separat verdrillt oder geschirmt. Falls das WS2811 Signal den stört, nutzen wir das Feature nicht.
- Externe Hardware-Features
  - Pins auf Federzugklemmen:
    - 14x Bus-Kabel
      - 8x Power: 2x 24V rein, 2x raus, ebenso für GND (damit man das Kabel direkt anklemmen kann)
        - Alternativ nur 4x und Doppel-Aderendhülsen nehmen. Ist eigentlich auch ok.
        - Einige Klemmen können nur AWG18=0.8mm² - das reicht nicht.
        - KF250T-5.0-2*13P kann 1.5mm², d.h. da geht es.
      - 4x RS485: rein und raus (und beim letzten nen Widerstand statt weiteres Kabel)
      - 2x WS2812 vom/zum Kabel
    - 8x Heizung
      - 2x 24V Ausgang mit PWM für Wachsmotor, 500 mA Peak (einige sec), 85 mA continuous
      - 2x Strom messen auf den 24V Ausgängen
        - bevorzugt: high-side schalten, low-side messen -> deshalb extra Pin nötig
        - alternativ beides low-side und zum passenden Zeitpunkt messen, aber dedizierter 24V Pin ist trotzdem praktisch
        - Sofern der Wachsmotor keinen relevanten induktiven Anteil hat (gut möglich - ist ein Heizdraht), würde low-side messen+schalten reichen,
          weil dann müssen wir nur während angeschaltet messen.
        - Der Grund für Strom messen wäre, dass ich hoffe damit die Temperatur vom Wachs abzuschätzen, weil warum sollte sich sonst der Strom von
          480 mA auf 85 mA reduzieren (laut einem Datenblatt von so einem Aktor). Ist aber nur nice-to-have, nicht nötig. Beziehungsweise schon
          irgendwie nötig, wenn/weil wir vorhaben die Power-Supply nicht auf Peak auszulegen und versetzt zu schalten.
      - 4x Digital-Eingang für Reed-Relay (2 pro Fenster); aber Umsetzung später, nur Eingänge vorsehen
    - 2x 5V Ausgang
      - I2C
      - WS2812
      - DS18B20
    - 1x GND
    - 1x 0-10V Eingang
    - TODO: Was wäre noch sinnvoll?
  - Features ohne extra Pin:
    - 1x 24V Versorgung messen
    - Nein: 1x DS18B20 oder DS18B20+ als Temperatur-Sensor und Unique ID
      - Eher nicht. Der kostet 1€, wird im Gehäuse nur Mist messen und eine Unique ID haben wir auch so: https://stackoverflow.com/a/74320491
      - Man könnte LM335DT nehmen, aber weil der analog ist hätten wir da auch Offset-Fehler durch die Referenzspannung wie bei dem integrierten
        Sensor im RP2040 (siehe Datenblatt, Section 4.9.5). Bei 1% Fehler in der Referenzspannung sind es aber nur 0.8 K statt 4 K wie bei dem integrierten.
      - Zu dem integrierten ist darüber hinaus leider nichts angegeben.
  - User Interface:
    - Ich dachte zunächst an seitwärts gerichtet und Loch ins Gehäuse machen, d.h. WS2812-4020 und 90 Grad gekippte Taster. Aber ist eigentlich nur
      unnötig Aufwand, weil das Gehäuse ist werkzeuglos zu öffnen und beinhaltet keine gefährlichen Spannungen.
    - 1x LED am MCU, z.B. RGB; zum Debuggen vom RS485 und MCU
    - 1x LED in der WS2812 Leitung, zum Debuggen davon
    - 1x Taster für Reset - nicht im Betrieb nutzbar
    - 1x Taster für USB Bootloader - nicht im Betrieb nutzbar, weil hängt am CS vom Flash
    - 1x Taster für unseren Bootloader (z.B. altes Image starten). Im Betrieb nutzbar, z.B. zum Adressen anlernen.
    - 1x USB. Den eventuell schon seitlich, weil sonst teuer und schwer erhältlich.
    - LEDs und Taster nicht dahin, wo Kabel lang gehen.
- Hardware-Design
  - MCU
    - https://datasheets.raspberrypi.com/rp2040/rp2040-datasheet.pdf
    - https://datasheets.raspberrypi.com/rp2040/hardware-design-with-rp2040.pdf
    - Aber vor allem den Pico kopieren: https://datasheets.raspberrypi.com/pico/pico-datasheet.pdf
  - Power
    - Wir brauchen kaum Leistung, d.h. einfach nen LDO nehmen. Leistung für den Wachsmotor geht nicht durch den LDO.
    - Diode als Verpolungsschutz (nicht so richtig nötig) und um den MCU optional von USB zu versorgen.
      - Diode von USB muss so sein, dass nach dem LDO noch 3.3V raus kommt. Eventuell MOSFET nehmen.
    - Die vier 24V und GND auf der Platine nebeneinander und Plane mit Vias. Da fließen ggf 8A drüber.
  - Anschlussklemmen:
    - Die steckbaren bauen zu groß und zu hoch: https://www.lcsc.com/products/Pluggable-System-Terminal-Block_11071.html
      - z.B. https://www.lcsc.com/product-detail/Pluggable-System-Terminal-Block_Cixi-Kefa-Elec-KF2EDGKNHG-3-5-2-9P_C2923078.html
      - Das sind 32x17 mm an Fläche für 2x9 Pins, was an sich sogar noch geht. Aber 23 von 32 mm in der Höhe alleine für den steckbaren Teil passt
        einfach nicht. Die Kabel würden nach oben rausgehen und da sind 9 mm echt wenig - und da gehen noch Gecko, PCB und der feste Teil der Klemme ab.
      - 3€ ist auch nicht grad wenig.
    - Deshalb lieber solche: https://www.lcsc.com/products/Spring-Clamp-System-Terminal-Block_432.html
      - 41x22mm für 2x8 Pins: https://www.lcsc.com/product-detail/Spring-Clamp-System-Terminal-Block_Cixi-Kefa-Elec-KF250T-5-0-2-8P_C976542.html
        - 2x13 wäre knapp genug, aber dann sind wir bei 66 mm: https://www.lcsc.com/product-detail/Spring-Clamp-System-Terminal-Block_Cixi-Kefa-Elec-KF250T-5-0-2-13P_C976547.html
        - Aber nehmen wir das erstmal für die weitere Rechnung.
      - Mit noch 2x4 daneben mag das knapp reichen.
      - 23x18mm für 2x6 Pins, aber kosten 3€: https://www.lcsc.com/product-detail/Spring-Clamp-System-Terminal-Block_Cixi-Kefa-Elec-KF207RH-3-5-2-6P_C2975066.html
    - Ich würde das PCB bis quasi zum Rand gehen lassen, aber Kabeleinführung braucht Platz. Daher Klemmen zur Platinenmitte zeigen lassen
      und Kabel einmal über die Platine führen.
    - Gecko-Tape sollte definitiv auch da unter der Platine sein, wo die Klemmen sitzen!
  - Platz:
    - Wir haben grob 66x66 mm und 32 in der Höhe. Das sind 43 dm². Da geht aber noch etwas weg wegen den Plastikpins und den Schrauben.
    - Der Raspi Pico hat 50x20 mm, also 10 dm². Der ist aber nicht gerade platzsparend gebaut.
    - Anschlussklemmen KF250T-5.0-2*13P mit 66x22m, also 15 dm².
      - Plus wenn wir die echt nehmen, kostet uns das 5 mm in der Tiefe, d.h. 5x66 also 3.3 dm².
      - Falls wir das doppelte nehmen können, wäre sinnvoll Platz für Beschriftung.
    - User Interface: 2x LED mit 5x5mm plus Abstand, also 0.4 dm². 3x Taster mit sagen wir mal 8x6mm, also 0.5 dm². Zusammen 2 dm².
    - Damit haben wir noch 13 dm² für MOSFETs und so. Und vielleicht bleibt dann echt noch mal 3.3 dm² für Beschriftung übrig.
  - Strom messen
    - Gut, dass ich mal LTspice dagegen geworfen habe: Wenn ich low-side den Strom messe, wird der leider negativ, sobald ich die high-side abschalte.
    - High-side Messung mit LT138 oder so mag vielleicht helfen, aber der kostet 1.5€.
    - INA2180A1IDGKR für 0.45€ würde wohl gehen. Und der hat dann schon zwei Channel.
    - Einziges Problem am INA2180 ist, dass 26V das Absolute Maximum sind. Das ist mir doch etwas knapp. Und wenn wir nur deshalb nicht die Spannung etwas
      hoch drehen können, wäre schade.
  - MCU Pinout:
    - 4x ADC ist klar. Da gibt's nur vier von leider.
      - GPIO26..29
    - 1x I2C, PIO, PWM für die Digital-Ausgänge. Eventuell wäre auch SPI TX hilfreich, falls das für WS2812 besser geht als PIO.
      - I2C gibt's alle zwei Pins, abwechselnd I2C0 und I2C1.
      - SPI und UART sind beides 4-er Gruppen, d.h. SPI TX und UART TX bekomme ich nicht beide (oder ich muss es mit zwei Pins verbinden).
        - Andererseits steht WS2812 mit PIO sogar als Beispiel im Datenblatt.
        - UART auch.
      - PWM gibt's quasi überall.
      - PIOs gibt's beide überall und der Start-Offset ist einstellbar.
      - -> GPIO24+25: UART1 RX/TX, I2C0, PWM4
      - Eventuell zusätzlich GPIO23 für SPI0 TX und GPIO18 für SPI0 SCK, aber eigentlich nicht sinnvoll weil langsam. Und CS müsste man über GPIO21 über den
        Widerstand vom Digital-Eingang treiben. -> Nein, weil sonst habe ich keine Pins für Taster mehr.
    - 2x SBU
      - ebenfalls auf UART1 und wenn möglich I2C0 -> 4+5 oder 8+9
    - 1x I2C auf Stiftleiste für optionales Display.
      - I2C0, d.h. 4*n+0
      - // 8+9, weil da ist PWM4, was wir schon benutzen. -> Nein, da ist SBU.
    - 5x PWM für LEDs.
      - Quasi überall, aber nicht PWM4 nehmen.
    - 2x PWM für Heizung.
    - 1x UART für RS485
      - UART0 nehmen -> 0+1, 12+13, 16+17
      - Erstmal 16+17 und TX_EN auf 15.
    - VBUS_DET? Der Pico hat es an GPIO24 (mit Spannungsteiler), was nicht passt. Der RP2040 Zero hat es nicht. Aber evtl wollen wir USB schlafen legen.
      - GPIO ??
    - 4x Reed / Digital-Eingang
      - Im Prinzip egal wohin, sofern man es nicht anderweitig nutzt.
      - UART RX
      - GPIO20 oder GPIO22 sind Clock Inputs. Das könnte man eventuell als Frequenzzähler nutzen.
      - GPIO19 bis GPIO22: UART1 RX, SPI0 RX
    - Taster-Matrix:
      - Dual-Purpose Ausgänge:
        - TX solange TX_EN nicht gesetzt
        - 5x LED theoretisch aber die ziehen runter und ggf wollen wir die aktiv low treiben; weiß vielleicht?
        - 2x I2C, aber die PU stören vermutlich (wenn mehr als 1 Taster gedrückt) -> Dioden hier oder in der Taster-Matrix sollten helfen
      - GPIO 7, 18, 23
- Protokoll:
  - Modbus RTU:
    - Viel einfacher wird's nicht, solange man nur die Register-Zugriffe implementiert.
    - Es gibt zwei Python Libraries.
    - CRC sind sinnvoll. Zusätzlich Parity muss ich nicht haben, aber was soll's.
    - Abstand zwischen Nachrichten würde ich evtl nicht nach jeder machen.
    - Die Zusatzfeatures für Diagnose (Event Log) und ID klingen sinnvoll.
  - Baudrate und so:
    - Aufstarten mit Standardeinstellung (19200, 8-E-1)
    - Auto-Baud per Break und dann Zugriff auf Gerät 0x55, wenn man eine andere Baudrate möchte.
    - Mit Adresse 0x55 würde ich dann auch die sonstige Zusatzfeatures machen wie den Broadcast für Auto-Discovery.
  - Auto-Discovery:
    - Ich habe wenig Lust, die Adressen manuell zu verteilen.
    - Simpel: "setze deine Adresse auf xx, falls dein Button gedrückt ist". Das kann ein Schreibzugriff auf ein bestimmtes Register von Broadcast-Gerät 0x55 sein.
      Adresse wird dann in den Flash geschrieben. Bevor sie eine Adresse im Flash haben, reagieren sie nur auf 0x55.
    - Auto-Discovery ginge auch einfach mit Broadcast und Backoff. Parameter wie Anzahl der Backoff Slots, Seed und die Wahrscheinlichkeit überhaupt zu antworten
      stehen mit in dem Broadcast. Es gibt eine maximale Zeit und nach der darf nicht mehr geantwortet werden, damit wieder normale Kommunikation möglich ist.
      - Man setzt ein Flag im Device für "ich kenne dich schon". Das deaktiviert Reaktion auf den Broadcast (ggf optional per Flag in dem Broadcast) und erlaubt
        dem zentralen Controller einen Reset des Geräts festzustellen.
      - Der Vorschlag kam so halb von ChatGPT. Meine Variante wäre eher was in der Art von DS18B20 gewesen, evtl mit mehreren Zeitslots um direkt 4 bit abzufragen.
      - Der Vorteil ist, dass man mit allen Geräten reden kann, ohne sie anzulernen (und man weiß nur nicht, welches wo ist).
      - Die Adresse ist entweder permanent im Flash oder die zentrale Steuerung merkt sich die Chip-ID vom MCU und vergibt die Modbus-Adressen bei jedem Start neu.
- Non-Features:
  - USB Host: Der MCU kann es und wäre cool zu haben für Erweiterungen.
    - VBUS EN per P-MOS auf VBUS (und ggf ersetzt der die existierende Diode für die andere Richtung)
    - Die 5.1k PD so mit VBUS EN verbinden, dass die zu PU werden. Es muss aber ein PD dran, damit es sich im Bootloader korrekt als USB Device
      meldet. Das braucht etwas Kreativität, damit in beiden Fällen der Widerstand im richtigen Bereich liegt. Oder man muss einen Pin finden,
      den der Bootloader auf low treibt.
    - Problem: Geht auf keinen Fall standardkonform, weil wir nicht genug Strom auf 5V zur Verfügung stellen können.
    - Und wenn man sowieso die 5V extern einspeisen muss, brauche ich auf der Platine nix weiter zu tun.

TODO und weitere Gedanken:
- Spulen mit rein zum Motor für langsamere Anstiegszeit / EMV Abstrahlung auf der Zuleitung?
- Anschlussplan wird nicht auf die Platine passen, aber kann man in den Deckel kleben.

- Taster irgendwo nach oben, WS2811 nach rechts

- Tooling Holes and JLC part number

- Display-Board:
  - OLED mit SSD1306
  - Taster per Matrix oder I2C
  - Noch ein TMP102
  - eventuell eine LED

